﻿using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Layouts;
using ArcGIS.Desktop.Mapping;
using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ToolTester
{
    internal class MapTool1 : MapTool
    {
        public MapTool1()
        {
            IsSketchTool = true;
            SketchType = SketchGeometryType.Point;
            SketchOutputMode = SketchOutputMode.Map;
        }

        protected override Task OnToolActivateAsync(bool active)
        {
            return base.OnToolActivateAsync(active);
        }

        protected override Task<bool> OnSketchCompleteAsync(Geometry geometry)
        {
            return QueuedTask.Run(() =>
            {
                Uri reference = new Uri(@"C:\TEMP\TRIAL_GEOLOGY\GEO_GDB\GeoStyles\zzzgeologyhotlink.lyrx");
                Layer basemap = LayerFactory.Instance.CreateFeatureLayer(reference, MapView.Active.Map, LayerPosition.AddToBottom);
                var fLayer = this.ActiveMapView.GetSelectedLayers().FirstOrDefault() as FeatureLayer;  //condition="esri_mapping_featureLayerSelectedCondition" in the daml should prevent this.
                if (fLayer == null)
                return true;
                //use whatever field is been set as Display Field in the layer properties.
                var fldName = ((CIMFeatureLayer)fLayer.GetDefinition()).FeatureTable.DisplayField;
                    //MessageBox.Show(fldName, "Selected Field");
                    string fileName = GetFirstRow(fLayer, fldName, geometry);
                if (!string.IsNullOrWhiteSpace(fileName))
                {
                    Uri myUri = new Uri($@"C:\TEMP\TRIAL_GEOLOGY\GEO_GDB\GeoStyles\zzzgeologyhotlink.lyrx");
                    Debug.Print(fileName);
                    //todo: verify file exists, layer not already added, etc.
                    //Layer newlayer = LayerFactory.Instance.CreateFeatureLayer(myUri, this.ActiveMapView.Map, LayerPosition.AddToTop);
                    MapView.Active.Map.RemoveLayer(basemap);
                }
                return true;
            });
        }
        private string GetFirstRow(FeatureLayer fLayer, string fldName, Geometry geom)
        {
            string s = "";
            GeometryEngine.Instance.Project(geom, fLayer.GetSpatialReference());
            using (var cursor = fLayer.Search(new SpatialQueryFilter()
            {
                FilterGeometry = GeometryEngine.Instance.Project(geom, fLayer.GetSpatialReference()),
                SpatialRelationship = SpatialRelationship.Intersects,
                SubFields = fldName

            }))
            {
                if (cursor.MoveNext())
                    s = cursor.Current[fldName].ToString();
                //MessageBox.Show(s, "Selected String");
                Uri myUri = new Uri(@"C:\TEMP\TRIAL_GEOLOGY\GEO_GDB\GeoStyles\" + s + ".lyrx");
                Layer newlayer = LayerFactory.Instance.CreateFeatureLayer(myUri, MapView.Active.Map, LayerPosition.AddToTop);
            };
            return s;
        }
    }
}
